/* 
 *
 * (c) 2006 Aubit Computing Ltd
 * 
 */

#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include "libpq-fe.h"
#include "sql3types.h"

PGconn *con;
PGresult *res;
char *pghost = "";
char *pgport = NULL;
char *pgoptions = NULL;
char *pgtty = NULL;


char *dberr;
extern int verbose;
#define DBIO



int cnt=0;


int
DBIO_connect_db (char *dbname, char *uname, char *passwd)
{
  static char buff2[256];

  if (uname != 0 && strlen (uname) == 0)
    uname = 0;
  if (passwd != 0 && strlen (passwd) == 0)
    passwd = 0;


if (verbose>=2) {
	printf("pghost=%s\n",pghost?pghost:"NULL");
	printf("pgport=%s\n",pgport?pgport:"NULL");
	printf("pgoptions=%s\n",pgoptions?pgoptions:"NULL");
	printf("pgetty=%s\n",pgtty?pgtty:"NULL");
	printf("dbname=%s\n",dbname?dbname:"NULL");
	printf("uname=%s\n",uname?uname:"NULL");
	printf("passwd=%s\n",passwd?passwd:"NULL");
 }


  con = PQsetdbLogin (pghost, pgport, pgoptions, pgtty, dbname, uname, passwd);

  if (con == NULL)
    {

      dberr = "Could not connect to database";
      return 0;
    }


  if (PQstatus (con) == CONNECTION_BAD)
    {
      if (PQerrorMessage (con))
	sprintf (buff2, "%s - %s", PQerrorMessage (con), dbname);
      else
	sprintf (buff2, "%s - No explanation from the backend", dbname);
      dberr = buff2;
      return 0;
    }

  return 1;
}



int DBIO_isok (PGresult * res)
{
int n;
if (verbose>2) { printf("Result : %p\n",res); }
n=PQresultStatus (res);
if (verbose>2) { printf("PQResult=%d\n",n); }
  switch (n) 
    {
    case PGRES_COMMAND_OK:
    case PGRES_TUPLES_OK:
      return 1;
    }


  dberr = "Unexpected postgres return code";
  return 0;
}

int
DBIO_clear_table (char *tabname)
{
  char buff[255];
  int ok;
  sprintf (buff, "delete from %s ", tabname);
if (verbose>=2) { printf("PQExec : %s\n",buff); }

  res = PQexec (con, buff);
  if (res == 0)
    return 0;
  if (DBIO_isok (res))
    ok = 1;
  else
    ok = 0;
  PQclear (res);
  return ok;
}


int DBIO_execute_sql(char *sql) {
int ok;

  if (verbose>=2) { printf("PQExec.1 : %s\n",sql); }
  res = PQexec (con, sql);
  if (res == 0) {
		printf("res=0\n");
		return 0;
  }



  if (DBIO_isok (res)) {
    ok = 1;
  } else {
    ok = 0;
  }
  
  PQclear (res);
  return ok;
}


int DBIO_load_unl(char *tabname,char *filename) {
char buff[1024];
	if (!DBIO_execute_sql("BEGIN WORK;")) {
		fprintf(stderr,"Begin failed\n");
		exit(2);
	}
	sprintf(buff,"LOAD FROM '%s' DELIMITER '|' INSERT INTO  %s ;",filename,tabname);
	if (!DBIO_execute_sql(buff)) {
		fprintf(stderr,"failed to exec : %s\n",buff);
		exit(2);
	}
		
	if (!DBIO_execute_sql("COMMIT WORK;")) {
		fprintf(stderr,"commit failed\n");
		exit(2);
	}
	unlink(filename);
	return 1;
}
